unit mathlibmain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, AdvPars, ESBPCSMathLib, Grids, AdvGrid, AdvSprd, ExtCtrls,
  StdCtrls, ESBPCSUrlLabel, ESBPCSLabel;

type
  TForm1 = class(TForm)
    PC: TPageControl;
    Constants: TTabSheet;
    About: TTabSheet;
    AdvSpreadGrid1: TAdvSpreadGrid;
    ESBPCSMathLib1: TESBPCSMathLib;
    Panel1: TPanel;
    LibBinder1: TLibBinder;
    Button1: TButton;
    Math: TTabSheet;
    Panel2: TPanel;
    Button2: TButton;
    AdvSpreadGrid2: TAdvSpreadGrid;
    PDF: TTabSheet;
    Panel3: TPanel;
    Button3: TButton;
    AdvSpreadGrid3: TAdvSpreadGrid;
    DescStats: TTabSheet;
    Panel4: TPanel;
    Button4: TButton;
    AdvSpreadGrid4: TAdvSpreadGrid;
    ESBPCSLabel1: TESBPCSLabel;
    ESBUrlLabel1: TESBUrlLabel;
    ESBPCSLabel2: TESBPCSLabel;
    ESBUrlLabel2: TESBUrlLabel;
    ESBPCSLabel3: TESBPCSLabel;
    ESBUrlLabel3: TESBUrlLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
	I: Integer;
begin
	Randomize;

	PC.ActivePage := Constants;

	with AdvSpreadGrid1 do
	begin
		ColWidths [1] := 200;
		ColWidths [2] := 200;

		Cells [1, 0] := 'Constant';
		Cells [2, 0] := 'Value';

		Cells [1, 1] := 'Pi';
		Cells [2, 1] := '=ESBPi';
		Cells [1, 2] := 'Square Root of 5';
		Cells [2, 2] := '=Sqrt5';
		Cells [1, 3] := 'Cube Root of 2';
		Cells [2, 3] := '=Cbrt2';
		Cells [1, 4] := 'Invers Square Root of Pi';
		Cells [2, 4] := '=InvSqrtPi';
		Cells [1, 5] := 'Natural Constant raised to Pi';
		Cells [2, 5] := '=ESBEPi';
		Cells [1, 6] := 'Log of 2 to Base 10';
		Cells [2, 6] := '=Log2Base10';
		Cells [1, 7] := 'Log of 10 to Base 20';
		Cells [2, 7] := '=Log10Base2';
		Cells [1, 8] := 'Parsec measured in metres';
		Cells [2, 8] := '=Parsec';
		Cells [1, 9] := 'Avogadro''s Constant';
		Cells [2, 9] := '=Avogadro';
		Cells [1, 10] := 'Speed of Sound in Dry Air (m/s)';
		Cells [2, 10] := '=MachOne';
		Cells [1, 11] := 'Planck''s Constant';
		Cells [2, 11] := '=Planck';
		Cells [1, 12] := 'Absolute Zero (in Fahrenheit)';
		Cells [2, 12] := '=AbsZeroF';

                Recalc;
	end;

	with AdvSpreadGrid2 do
	begin
		ColWidths [1] := 200;
		ColWidths [2] := 100;
		ColWidths [3] := 100;
		ColWidths [4] := 100;

		Cells [1, 0] := 'Description';

		Cells [1, 1] := 'Greatest Common Divisor';
		Cells [2, 1] := '846';
		Cells [3, 1] := '648';
		Cells [4, 1] := '=GCD (B1, C1)';

		Cells [1, 2] := 'Lowest Common Multiple';
		Cells [2, 2] := '286';
		Cells [3, 2] := '468';
		Cells [4, 2] := '=LCM (B2, C2)';

		Cells [1, 3] := 'Inverse Cosine, result in Radians';
		Cells [2, 3] := '=InvSqrt2';
		Cells [3, 3] := '=ESBARCCOS (B3)';

		Cells [1, 4] := 'Sine of Angle in Degrees';
		Cells [2, 4] := '45';
		Cells [3, 4] := '=ESBSinDeg (B4)';

		Cells [1, 5] := 'Gamma Function';
		Cells [2, 5] := '2.5';
		Cells [3, 5] := '=Gamma (B5)';

		Cells [1, 6] := 'LnGamma Function';
		Cells [2, 6] := '450';
		Cells [3, 6] := '=LnGamma (B6)';

		Cells [1, 7] := 'Permutations';
		Cells [2, 7] := '12';
		Cells [3, 7] := '5';
		Cells [4, 7] := '=ESBPERM (B7, C7)';

		Cells [1, 8] := 'Combinations';
		Cells [2, 8] := '12';
		Cells [3, 8] := '5';
		Cells [4, 8] := '=ESBCOMB (B7, C7)';

                Recalc;
	end;

	with AdvSpreadGrid3 do
	begin
		ColWidths [1] := 300;
		ColWidths [2] := 120;

		Cells [1, 0] := 'Description';
		Cells [2, 0] := 'Result';

		Cells [1, 1] := 'Binomial Distribution';

		Cells [1, 2] := 'Prob. of 4 Successes given 10 Trials, Succ = 1 in 4';
		Cells [2, 2] := '=BinomDist (4, 10, 1/4, False)';
		Cells [1, 3] := 'Prob. of <= 5 Successes given 12 Trials, Succ = 2 in 3';
		Cells [2, 3] := '=BinomDist (5, 12, 2/3, True)';
		Cells [1, 4] := 'Prob. of > 5 Successes given 12 Trials, Succ = 2 in 3';
		Cells [2, 4] := '=1 - BinomDist (5, 12, 2/3, True)';

		Cells [1, 6] := 'Poisson Distribution - Cars arrive on ave at 360/hr';
		Cells [1, 7] := 'Prob. 2 cars will arrive in specified minute';
		Cells [2, 7] := '=Poisson (2, 360/60, False)';
		Cells [1, 8] := 'Prob. at least 4 cars will arrive in specified minute';
		Cells [2, 8] := '=1 - Poisson (3, 360/60, True)';
		Cells [1, 8] := 'Prob. between 3 and 5 cars incl. will arrive in specified minute';
		Cells [2, 8] := '=Poisson (5, 360/60, True) - Poisson (2, 360/60, True)';

                Recalc;

	end;

	with AdvSpreadGrid4 do
	begin
		ColWidths [1] := 200;
		ColWidths [2] := 150;
		ColWidths [3] := 100;

		Cells [1, 0] := 'Description';
		Cells [2, 0] := 'Value';
		Cells [3, 0] := 'Elements';

		for I := 1 to 15 do
			Floats [3, I] := Random * 100;

		Cells [1, 1] := 'Arithmetic Mean';
		Cells [2, 1] := '=ESBAve(C1:C15)';
		Cells [1, 2] := 'Median';
		Cells [2, 2] := '=ESBMedian(C1:C15)';
		Cells [1, 3] := 'Sample Variance';
		Cells [2, 3] := '=ESBVarSamp(C1:C15)';
		Cells [1, 4] := 'Population Variance';
		Cells [2, 4] := '=ESBVarPop(C1:C15)';
		Cells [1, 5] := 'Sample Standard Deviation';
		Cells [2, 5] := '=ESBStdDevSamp(C1:C15)';
		Cells [1, 6] := 'Population Standard Deviation';
		Cells [2, 6] := '=ESBStdDevPop(C1:C15)';
		Cells [1, 7] := 'Inter-Quartile Range';
		Cells [2, 7] := '=ESBIQR(C1:C15)';
		Cells [1, 8] := 'Skew (Sample)';
		Cells [2, 8] := '=SkewSamp(C1:C15)';
		Cells [1, 9] := 'Kurtosis (Sample)';
		Cells [2, 9] := '=KurtosisSamp(C1:C15)';
		Cells [1, 10] := 'Root Mean Square';
		Cells [2, 10] := '=ESBRMS(C1:C15)';

                Recalc;
	end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
	if Button1.Caption = 'Show Formulae' then
	begin
		Button1.Caption := 'Hide Formulae';
		AdvSpreadGrid1.ShowFormula := True;
	end
	else
	begin
		Button1.Caption := 'Show Formulae';
		AdvSpreadGrid1.ShowFormula := False;
	end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
	if Button2.Caption = 'Show Formulae' then
	begin
		Button2.Caption := 'Hide Formulae';
		AdvSpreadGrid2.ShowFormula := True;
	end
	else
	begin
		Button2.Caption := 'Show Formulae';
		AdvSpreadGrid2.ShowFormula := False;
	end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
	if Button3.Caption = 'Show Formulae' then
	begin
		Button3.Caption := 'Hide Formulae';
		AdvSpreadGrid3.ShowFormula := True;
	end
	else
	begin
		Button3.Caption := 'Show Formulae';
		AdvSpreadGrid3.ShowFormula := False;
	end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
	if Button4.Caption = 'Show Formulae' then
	begin
		Button4.Caption := 'Hide Formulae';
		AdvSpreadGrid4.ShowFormula := True;
	end
	else
	begin
		Button4.Caption := 'Show Formulae';
		AdvSpreadGrid4.ShowFormula := False;
	end;
end;

end.
